=== debian/changelog ===
cantata (0.9.2-0ubuntu1) raring; urgency=low

  * Initial release

 -- Ben Vassie <vassie@ntlworld.com>  Fri, 25 Jan 2013 10:17:18 +0000
