=== debian/control ===
Source: cantata
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Ben Vassie <vassie@ntlworld.com>
Build-Depends: debhelper (>= 8.0.0), cmake, cmake, qt4-dev-tools, libqt4-core, libqt4-gui, libqt4-network, libqt4-xml, libqt4-dbus, kdelibs5-dev, libqt4-webkit, libtag1-dev, libmtp-dev, ffmpeg, libspeexdsp-dev, libmpeg3-dev, libavcodec-dev, libavformat-dev, libavutil-dev, libmpg123-dev, libtag-extras-dev, pkg-config, libx11-dev, libqtwebkit-dev
Standards-Version: 3.9.4
Homepage: http://code.google.com/p/cantata

Package: cantata
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: client for music player daemon (MPD)
 Cantata is a Qt4/KDE4 client for the music player daemon
 (MPD). Originally started as a fork of QtMPC, the code is now very
 different. Cantata can be compiled with KDE support, or as a pure Qt4
 application. The interface is very configurable - most views can be
 shown as either a list or tree structure.
