=== debian/watch ===
version=3

opts=\
downloadurlmangle=s|.*[?]name=(.*?)&.*|http://cantata.googlecode.com/files/$1|,\
filenamemangle=s|[^/]+[?]name=(.*?)&.*|$1| \
http://code.google.com/p/cantata/downloads/detail[?]name=cantata-([0-9.]+).tar.bz2&.*
