=== debian/changelog ===
cantata (1.0.2-0ubuntu2) saucy; urgency=low

  * New upstream release
  * New build-depends libcdparanoia-dev, libmusicbrainz5-dev, libcddb2-dev

 -- Ben Vassie <vassie@ntlworld.com>  Tue, 21 May 2013 20:53:39 +0100
