=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
 XSBC-Original-Maintainer: Ben Vassie <vassie@ntlworld.com>
-Build-Depends: debhelper (>= 8.0.0), cmake, cmake, qt4-dev-tools, libqt4-core, libqt4-gui, libqt4-network, libqt4-xml, libqt4-dbus, kdelibs5-dev, libqt4-webkit, libtag1-dev, libmtp-dev, ffmpeg, libspeexdsp-dev, libmpeg3-dev, libavcodec-dev, libavformat-dev, libavutil-dev, libmpg123-dev, libtag-extras-dev, pkg-config, libx11-dev, libqtwebkit-dev
+Build-Depends: debhelper (>= 8.0.0), cmake, cmake, qt4-dev-tools, libqt4-core, libqt4-gui, libqt4-network, libqt4-xml, libqt4-dbus, kdelibs5-dev, libqt4-webkit, libtag1-dev, libmtp-dev, ffmpeg, libspeexdsp-dev, libmpeg3-dev, libavcodec-dev, libavformat-dev, libavutil-dev, libmpg123-dev, libtag-extras-dev, pkg-config, libx11-dev, libqtwebkit-dev, libcdparanoia-dev, libmusicbrainz5-dev, libcddb2-dev
 Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/cantata
